package facturation.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

/**
 * Un objet ConnectionFactory sert à créer des connections à une base
 * de données donnée. Il connaît les caractéristiques de celle-ci.
 * @author rosmord
 *
 */
public class ConnectionFactory {
	
	private String url;
	private String login;
	private String password;
	
	
	
	public ConnectionFactory(String url, String login, String password, String driverClassName) throws ClassNotFoundException {
		this.url = url;
		this.login = login;
		this.password = password;
		// Chargement du driver.
		Class.forName(driverClassName);
	}



	/**
	 * Crée une connection vers la base de données.
	 * Ne prend pas d'argument (ceux-ci sont fournis au constructeur).
	 * @return
	 * @throws SQLException 
	 */
	public Connection open() throws SQLException {
		return DriverManager.getConnection(url, login, password);
	}
}
