/**
 * 
 */
package facturation.dao;

import java.sql.*;

/**
 * @author rosmord
 *
 */
public class IDGeneratorDAO {
	ConnectionFactory connectionFactory;
	
	
	public IDGeneratorDAO(ConnectionFactory connectionFactory) {
		this.connectionFactory = connectionFactory;
	}


	/**
	 * Crée un nouvel ID pour une table concernée.
	 * 
	 * @param idName : nom de l'ID
	 * @param tableName : nom de la table.
	 * @throws SQLException
	 */
	public  int getNextId(String idName, String tableName) throws SQLException {
		Connection connection = connectionFactory.open();
		PreparedStatement pst = null;
		ResultSet r= null;
		int result= 1;
		try {
			pst = connection
					.prepareStatement("select max("+ idName +") from "+ tableName);
			r= pst.executeQuery();
			// 1 résultat max.
			if (r.next()) {
				result= r.getInt(1) + 1;
			}	
		} finally {
			if (r!= null)
				r.close();
			if (pst != null)
				pst.close();
			connection.close();
		}
		return result;
	}
}
